#include "ranking.h"

Ranking::Ranking()
{
	ifstream fic("ranking.bin", ios::in);
	
	posRanking posicion;
	string aux;
	
	if(fic.is_open())
	{
		for(int i=0;i<5;i++)
		{
			aux = "";
			getline(fic,posicion.nombre);
			getline(fic,aux);
			posicion.puntuacion = atoi(aux.c_str());
			ranking.push_back(posicion);
		}
		fic.close();
	}
	else
	{
		posRanking pos1; pos1.nombre = "Maestro Splinter"; pos1.puntuacion = 16000;
		posRanking pos2; pos2.nombre = "Donatello"; pos2.puntuacion = 8000;
		posRanking pos3; pos3.nombre = "Raphael"; pos3.puntuacion = 4000;
		posRanking pos4; pos4.nombre = "Michelangelo"; pos4.puntuacion = 2000;
		posRanking pos5; pos5.nombre = "Leonardo"; pos5.puntuacion = 1000;
		
		ranking.push_back(pos1);
		ranking.push_back(pos2);
		ranking.push_back(pos3);
		ranking.push_back(pos4);
		ranking.push_back(pos5);
	}
}

Ranking::~Ranking()
{
	ofstream fic("ranking.bin", ios::out);
	
	if(!fic)
		cout << "Se ha producido un error en la apertura del fichero de puntuaciones" << endl;
	else
	{
		for(unsigned int i=0;i<ranking.size();i++)
		{
			fic << ranking[i].nombre << endl;
			fic << ranking[i].puntuacion;
			if(i < ranking.size()-1)
				fic << endl;
		}

		fic.close();
	}
}

bool ordenar (posRanking i,posRanking j) { return (i.puntuacion > j.puntuacion); }

bool
Ranking::top(int puntuacion, string jugador)
{
	bool retorno = false;
	
	if(puntuacion > ranking[ranking.size()-1].puntuacion)
	{
		
		posRanking pos;
		pos.nombre = jugador;
		pos.puntuacion = puntuacion;
		ranking.push_back(pos);
		sort(ranking.begin(),ranking.end(),ordenar);
		ranking.pop_back();
		retorno = true;
	}
	return retorno;
}



int 
Ranking::ejecutar()
{
	StdPijo& stdp = StdPijo::p();
	
	int retorno = ERANKING;
	
	if(stdp.getKey() == ' ')
		retorno = EMENU;
	
	return retorno;
}

void 
Ranking::mostrar()
{
	StdPijo& stdp = StdPijo::p();
	
	stdp.box(0,0,80,24);
	
	stdp.setColor(ABOLD,CYELLOW,CBLACK);
	mvprintw(3,4," ______     ______     ______     _    __   _____    ______     ______  ");
	mvprintw(4,4,"| |  | \\   | |  | |   | |  \\ \\   | |  / /    | |    | |  \\ \\   | | ____ ");
	mvprintw(5,4,"| |__| |   | |__| |   | |  | |   | |-< <     | |    | |  | |   | |  | | ");
	mvprintw(6,4,"|_|  \\_\\   |_|  |_|   |_|  |_|   |_|  \\_\\   _|_|_   |_|  |_|   |_|__|_| ");
	stdp.setColor(ANORMAL,CWHITE,CBLACK);
	
	for(unsigned int i=0;i<ranking.size();i++)
	{
		mvprintw(10+i*2,30,"%dº",i+1); 
		mvaddstr(10+i*2,34,ranking[i].nombre.c_str());
		mvprintw(10+i*2,35+ranking[i].nombre.length(),"%d",ranking[i].puntuacion); 
	}
	mvprintw(21,21,"Pulse SPACEBAR para volver al menú");
}